#ifndef AISL_STREAM_H_A9EC6601_34B2_4F3E_B631_EEDA8B6EF0D3
#define AISL_STREAM_H_A9EC6601_34B2_4F3E_B631_EEDA8B6EF0D3

#include <aisl/types.h>
#include <aisl/stream.h>

#define AISL_STREAM(x) ((aisl_stream_t) x)

typedef enum
{
    AISL_STREAM_STATE_IDLE

  , AISL_STREAM_STATE_WAIT_HEADER
  , AISL_STREAM_STATE_WAIT_BODY

  , AISL_STREAM_STATE_READY

  , AISL_STREAM_STATE_SEND_HEADER
  , AISL_STREAM_STATE_SEND_BODY

  , AISL_STREAM_STATE_DONE

} aisl_stream_state_t;


aisl_stream_t
aisl_stream_new(aisl_client_t client, int id );


void
aisl_stream_free(aisl_stream_t stream);


void
aisl_stream_set_chunked_output(aisl_stream_t stream, bool value);


bool
aisl_stream_get_chunked_output(aisl_stream_t stream);


int32_t
aisl_stream_get_buffer_space(aisl_stream_t stream);


int32_t
aisl_stream_get_buffer_size(aisl_stream_t stream);


void
aisl_stream_get_buffer(aisl_stream_t stream, char ** data, int32_t * size);


void
aisl_stream_shift(aisl_stream_t stream, int32_t offset);


bool
aisl_stream_has_data(aisl_stream_t stream);


aisl_stream_state_t
aisl_stream_get_state(aisl_stream_t stream);

#endif /* !AISL_STREAM_H */
